
;*******************************************************************************
;				Clock_RTC.asm
;	FM-   RDA5807M  LCD- Nokia5110    DS1307.
;  ATMEGA8    .  8 .
; 		  :
;-*-        .
;-*-           V+.
;-*-       V+  V-.
;-*-   .     CH+.
;-*-           CH-.
;-*-  ,         , 
;             CH+  CH-.
;-*-           
;            CH+  CH-.
;-*-        .
;-*-       .
;-*-      .
;-*-       EEPROM.
;-*-         
 ;      . 
;-*-    V+  V-.
;-*-         V-.
;-*-      .
;-*-        0  15.
;-*-       .
;-*-  "-"   ,   .
;-*-      ,   .
;-*-             10 
;
;  :
; PB0 - .   -
; PB1 - D/C     (1)   (0) LCD
; PB2 -     (0) LCD
; PB3 - DIN   LCD
; PB4 - RES   LCD (0)
; PB5 - CLK   LCD
; PB6 - 
; PB7 - 
;
; PC0 -      
; PC4 - (SDA) -    I2C
; PC5 - (SCL) -    I2C
;
; PD0 -  V+
; PD1 -  V-
; PD2 -    1    
; PD3 -  CH+
; PD4 -  CH-
; PD5 -       
; PD6 -     
; PD7 -     
;
;*******************************************************************************
	;     /
    .NOLIST                 ; 
	.include "m8def.inc"	;   - ATMega8
    .LIST                   ; 
    .device ATmega8         ; 
  	;   
	.def temp  = r16 		;
	.def temp1 = r17 		; 
	.def temp2 = r18 		; 
	.def temp3 = r19 		;  
	.def flags = r20 		; 
	.def time  = r21		;  
	.def F_3H  = r22		;.   
	.def F_3L  = r23		;.   
	.def freq  = r24		;   ( )
	.equ Tm_l  = 255		;  

;===============================================================================
	.DSEG					;   SRAM ()
	.ORG 0x060				;   
	decnum: 	.BYTE 5		;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	; ()  
	level:		.byte 1		; 
	volume:		.byte 1		;
	akkum:		.byte 2		; 
	T_clk:		.byte 3		; 
	prv_T:		.byte 3		; 
	D_clk:		.byte 3		; 
;=============================================================================
	.ESEG					;   EEPROM
	 Fst_EE:	.BYTE 1 	;   ( )
	 Vol_EE:	.BYTE 1 	; 
;=============================================================================
	.CSEG				;  
	.ORG 0 				; 
	rjmp RESET			;Reset
	rjmp INT_0			;  INT 0
	reti				;  INT 1
	reti				; / 2  
	rjmp OVF_T2			; / 2  
	reti  				; / 1   
	reti				; / 1     
	reti				; / 1     
	rjmp OVF_T1			; / 1  
	rjmp OVF_T0			; / 0  
	reti				;  SPI 
	reti				; UART   
	reti				; UART   
	reti				; UART  
	reti 				;   
	reti				; EEPROM 
	reti				;   
	reti    			;  - 2- 
	reti				; SPM
	
;============================================================================
RESET:	;   ,  
		;  
		LDI 	Temp, LOW(RAMEND)
		OUT 	SPL, Temp
		LDI 	Temp, HIGH(RAMEND)
		OUT 	SPH, Temp
		CLI							;   
;-----------------------------------------------------------------------------
		;  B,  .  LCD-
	 	ldi temp,0b11111111			;
		out DDRB,temp   			;      
		ldi temp,0b00000110			;   RES  SE 
		out PORTB,temp   			;
			;  
	 	ldi temp,0b00000000			;     
		out DDRC,temp   			;
		ldi temp,0b00110000			;
		out PORTC,temp   			;  
			;  D  .  
	 	ldi temp,0b11000000			;   D
		out DDRD,temp				;
		ldi temp,0b01111111			;
		out PORTD,temp				;  
			; 
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		clr temp					;   
		out TCNT0,temp				;
		out TCNT2,temp				;
		ldi temp,0b01000101			; .   
		out TIMSK,temp				;
		ldi temp,0b00000101			;  0   1/1024
		out TCCR0,temp				;
		out TCCR1B,temp				;  1   1/1024
		;  
		ldi temp,0b00000011			;    INT0
		out MCUCR,temp				;
		sei                         ;  
		
		; 
		ldi temp,0b10000111 		;
		out ADCSRA,temp				; . . 
		ldi temp,0b11000000 		;
		out ADMUX,temp				; VREF = 2,56 ,  . ADC0
		
		rcall InitCurrentState      ;  
;----------------------------------------------------------------------
	.MACRO DELAY					; 1   32 
		ldi time,@0					;    0
 		tst time					;,  0  R21  0
		brne PC-1					;
	.ENDMACRO
	
	.MACRO LOAD_ADDR 		 		;   16- 
		ldi @0l,low(@1)   			;: LOAD_ADDR Z,12365
		ldi @0h,high(@1)  			;
	.ENDMACRO
		
	.MACRO 	POZ_LCD					;    LCD:
		ldi temp,@0					;    ,
		rcall lcd_X					;
		ldi temp,@1					;   
		rcall lcd_Y					;
	.ENDMACRO						;: POZ_LCD 12,5
	
;===================   ==================================
		;  
		ldi temp,Tm_l				; 
		mov R12,temp				;  
		cbi PORTD,6		 			;  
		sbi PORTD,7					;  
		ldi temp,0b00000111			;  2   1/1024
		out TCCR2,temp				;
		; 
		rcall lcd_init				; LCD 
		rcall lcd_clr				; LCD
		;    
		POZ_LCD 0,0					;0- , 0- 
		LOAD_ADDR Z,Messg1*2		;.  Z  
		rcall Str_LCD				; .  LCD
		;    
		POZ_LCD 0,3					;0- , 3- 
		LOAD_ADDR Z,Messg3*2		;.  Z  
		rcall Str_LCD				;  LCD 
		; 
		rcall IIC_init				;  IIC
		rcall DS_Start				;  
		rcall out_1Hz				;   RTC  1 
		;  RDA5807
		ldi YL,LOW(Fst_EE)			;.  Y ..  
		clr YH						;
		ldi temp,15					; 
		sts volume,temp				;   = 15
		rcall Rd_St					;     EEPROM
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rcall type_vol				;    LCD
		DELAY 20					; 656 
		;      
		rcall Prnt_F				;   
		rcall rekog					;/  
		;    
		rcall ch_st					; RDA5807
		DELAY 20					; 656 
		; 
		clr r2						;  
		clr r8						;   
		clr r10						;  .  
		clr R13						;   
		clr freq					;  
		clr temp3					;  R19
		rcall U_bat					;   
		;    
		rcall DS_get_time			;      RTC
		clr temp					;
		sts prv_T,temp				;   
		sts prv_T+1,temp			;
		sts prv_T+2,temp			;
		rcall Cur_T					;    
		ldi temp,(1<<INT0)			;    INT_0
		out GICR,temp				;
		
;-------------------- ----------------------------------------------
main: 			; 
		in temp,PIND				; 
		com temp					; 
		andi temp,0b00011011		;  
		push temp					;
		lsr temp					; 
		andi temp,0b00001100		; . 
		mov R1,temp					; . 
		pop temp					;
		andi temp,0b00000011		; . 
		or R1,temp					;  
		;   ()
		DELAY 1						; 32  
		tst R2						;   ,
		breq main					;   
		cp r1,r2					;  , 
		breq PC+2					;    -
		rjmp long					;
		inc R10						;    
		rjmp main					;
		
		;  , .  
long:	mov temp,r10				;  
		cpi temp,50					;   -
		brmi lig_on					;   .  ,
		rcall mode_s				;  -    
		
lig_on:	;  
		ldi temp,Tm_l				; 
		mov R12,temp				;  
		cbi PORTD,6		 			;  
		sbi PORTD,7					;  
		ldi temp,0b00000111			;  2   1/1024
		out TCCR2,temp				;
		
		rcall U_bat					;   
		tst R8						;  :
		breq hand					;  -   
		rjmp ch_ch					;  -    
		
S_time:	POZ_LCD 0,5					;0- , 5- 
 		LOAD_ADDR Z,Messg18*2		;.  Z . .
 		rcall Str_LCD				;" .  "
		rcall HandlerMenu			; 
		rjmp m_loop					;    
		
mem_V:	rcall Wr_EEV				;   EEPROM
		clr R8						;
		rjmp m_loop					;    
		
ch_ch:	;  
		sbrc R8,0					;    ,-
		rjmp S_time					;    
		sbrc R8,1					;    
		rjmp mem_V					;    EEPROM
		sbrc R8,2					;   
		rjmp avto					;    
		sbrc R8,3					;   
		rjmp avto					;    
	; 	rjmp hand					;, -    
	 	
		;  
hand:	sbrc R2,2					;   CH+
		rcall St_Up					;     
		sbrc R2,3					;   CH-
		rcall St_Down				;     
		rjmp reg_V					;, -   
		
		;
avto:	sbrc R2,2					;   CH+
		rcall freq_Up				;    
		sbrc R2,3					;   CH-
		rcall freq_Down				;    
		
		; 
reg_V:	sbrc R2,0					;   +V
		rcall vol_up				;    
		sbrc R2,1					;   V-
		rcall vol_dw				;    
		
m_loop: clr R2						;  
		clr R10						;
		rjmp main					;   
		
;============================================================================
;			  
;  .    /  InitCurrentState
;----------------------------------------------------------------------------
	#define func(x)	Low(x),High(x) 	; 
	.equ End = 255					;  
	.equ CurrentState = 0x75 		;  .  
	.def p_men = r25				;  
		;   
  	Handlers: 	.dw HUpButton, HDownButton, HCursorButton, HEnterButton
			;    
		; 1-    (  )
		; 2-    (  )
		; 4:3  -   
		
	HUpButton:					; V+
		.db 1,1, func(H_up)		;
		.db 2,2, func(Min_up)	;
		.db End
		
	HDownButton:				; V-
		.db 1,1, func(H_dw)		;
		.db 2,2, func(Min_dw)	;
		.db End
		
	HCursorButton:				; CH+
		.db 1,2, func(kurs_1)	;
		.db 2,1, func(kurs_2)	;
		.db End
		
	HEnterButton:				; CH-
		.db 1,1, func(set_out)	;
		.db 2,1, func(set_out)	;
		.db End
		
;=============================================================================
;			  
;----------------------------------------------------------------------------
		;   -   
InitCurrentState:
		ldi r16, 1					;  
		sts CurrentState, r16		;.   
		ldi R25,1					;   1-  
		ret							;
		
;----------------------------------------------------------------------------
 Empty:  ret				; -  
		
;----------------------------------------------------------------------------
H_up:	; 
		lds temp,T_clk+2	;   . 
		cpi temp,0x23		;  
		brge ed_pl			; ,  
		andi temp,0xF0		; .  
		mov R11,temp		;  R11
		lds temp,T_clk+2	;   . 
		andi temp,0x0F		; .  
		inc temp			; .  
		cpi temp,10			;  10, -
		brlo du_i			;   
		mov temp,R11		;
		subi temp,(-0x10)	; . 
		mov R11,temp		;
du_i:	or temp,R11			;  
		sts T_clk+2,temp	;  
ed_pl:	clr temp			;
		sts prv_T+2,temp	;  
		rjmp Cur_T			;   
		
;----------------------------------------------------------------------------
H_dw:	; 
		lds temp,T_clk+2	;   . 
		tst temp			;  
		breq ed_mi			; ,  
		andi temp,0xF0		; .  
		mov R11,temp		;  R11
		lds temp,T_clk+2	;   . 
		andi temp,0x0F		; .  
		dec temp			; .  
		cpi temp,0			; 0, -
		brpl dw_i			;   
		mov temp,R11		;
		subi temp,0x10		; . 
		mov R11,temp		;
		ldi temp,9			;9  . 
dw_i:	or temp,R11			;  
		sts T_clk+2,temp	;  
ed_mi:	clr temp			;
		sts prv_T+2,temp	;  
		rjmp Cur_T			;   
		
;----------------------------------------------------------------------------
Min_up:	; 
		lds temp,T_clk+1	;   . 
		cpi temp,0x59		;  
		brge md_pl			; ,  
		andi temp,0xF0		; .  
		mov R11,temp		;  R11
		lds temp,T_clk+1	;   . 
		andi temp,0x0F		; .  
		inc temp			; .  
		cpi temp,10			;  10, -
		brlo mu_i			;   
		mov temp,R11		;
		subi temp,(-0x10)	; . 
		mov R11,temp		;
mu_i:	or temp,R11			;  
		sts T_clk+1,temp	;  
md_pl:	clr temp			;
		sts prv_T+1,temp	;  
		rjmp Cur_T			;    
		
;----------------------------------------------------------------------------
Min_dw:	; 
		lds temp,T_clk+1	;   . 
		tst temp			;  
		breq med_mi			; ,  
		andi temp,0xF0		; .  
		mov R11,temp		;  R11
		lds temp,T_clk+1	;   . 
		andi temp,0x0F		; .  
		dec temp			; .  
		cpi temp,0			; 0, -
		brpl mdw_i			;   
		mov temp,R11		;
		subi temp,0x10		; . 
		mov R11,temp		;
		ldi temp,9			;9  . 
mdw_i:	or temp,R11			;  
		sts T_clk+1,temp	;  
med_mi:	clr temp			;
		sts prv_T+1,temp	;  
		rjmp Cur_T			;    
		
;----------------------------------------------------------------------------
 kurs_1:  POZ_LCD 0,5			;0- , 5- 
 		LOAD_ADDR Z,Messg19*2	;.  Z . .
 		rcall Str_LCD			;" .  "
 		ret
 		
;----------------------------------------------------------------------------
kurs_2:  POZ_LCD 0,5			;0- , 5- 
 		LOAD_ADDR Z,Messg18*2	;.  Z . .
 		rcall Str_LCD			;" .  "
 		ret
 		
;----------------------------------------------------------------------------
set_out:
		rcall DS_Set_time		; .  RTC
 		clr R8					;   
 		ldi temp,(1<<INT0)		;    INT_0
		out GICR,temp			;
		rcall Rd_St				;     EEPROM
		rcall rekog				;/  
 		ret
 		
;=============================================================================
;				  
;		:  . R16 (temp)    1...4
;-----------------------------------------------------------------------------
HandlerMenu:	;cli
		;    
		mov temp,R2					;    
		cpi temp,4					;  4, -
		brne PC+2					;
		dec temp					;   = 3
		cpi temp,8					;  8, -
		brne PC+2					;
		lsr temp					;   = 4
		
		;   
		dec r16						; 1  . 0- 
		clr ZL						;  :
		clr ZH						;  Z <= 0
		mov ZL,R16					;ZL = R16     
		lsl	ZL						; ZL  2
		subi ZL,LOW(-(Handlers<<1))	; . .
		sbci ZH,HIGH(-(Handlers<<1));  
		lpm R16,Z+					;   . 
		lpm R17,Z					;   1-  
		movw ZH:ZL,R17:R16			;  . R17:R16    ZH:ZL
		lsl	ZL						;  2   
		rol ZH 						;
		lds r19,CurrentState		;    . .
		;
		;   ,    -
		;     ,  -  
	CheckState:		
		lpm r16,Z 					; 1-   
		cp r16,r19 					; ,    . .,
		breq ChangeState 			;      
		cpi r16,255 				;   , - 
		breq ExitHM 				;   /.,  - 
		adiw Z,4 					;   1- . . 
		rjmp CheckState	 			;    
		;
	ChangeState:
		adiw Z, 1					; . 2-  
		lpm r16, Z+	 				;    r16
		sts CurrentState, r16		;.  . .
		lpm R16, Z+		 			;  
		lpm R17, Z		 			;   R17:R16  
		movw ZH:ZL, R17:R16			;   ZH:ZL
		icall			 			;   (   ZH:ZL)
	ExitHM:
		clr temp					; temp    
	;	sei
		ret

;==============================================================================
;		     
Cur_T:	cli
		push temp
		push temp1
		push temp2
		push ZL
		push ZH
		push R20
			;  
		lds temp1,prv_T+1			;    
		lds temp2,prv_T+2			;
		lds R20,T_clk+2				;    
		tst R20						;  00,  -
		breq ind_H					;    
		cp R20,temp2				;   , -
		breq tst_min				;   
		
ind_H:		;  LCD 
		ldi temp,7					;7- 
		mov R6,temp					;  
		rcall lcd_XClk				;    
		ldi R16,3					; 3- 
		rcall lcd_Y					;  3- 
		rcall Dig_clok				;  LCD 
		
		ldi temp,0x0B				;  
		rcall Dig_Clk				;  LCD 
		
tst_min:	;  
		lds R20,T_clk+1				;    
		tst R20						;  00,  -
		breq ind_M					;    
		cp R20,temp1				;   , -
		breq tim_out				;   
		
ind_M:		;  LCD 
		ldi temp,13					;13- 
		mov R6,temp					;  
		rcall lcd_XClk				;    
		ldi R16,3					; 3- 
		rcall lcd_Y					;  3- 
		rcall Dig_clok				;  LCD 
tim_out:
		pop R20
		pop ZH
		pop ZL
		pop temp2
		pop temp1
		pop temp
		sei
		ret
		
;===========================================================================
Dig_clok:	;  LCD 
		mov temp,R20			;
		swap temp				; 
		andi temp,0x0F			; . 
	;	subi temp,-48			;   ASCII
		rcall Dig_Clk			;  LCD . 
		
		mov temp,R20			;
		andi temp,0x0F			; . 
	;	subi temp,-48			;   ASCII
		rcall Dig_Clk			;  LCD . 
		
		ret
;===========================================================================
;	/     1   
;---------------------------------------------------------------------------
INT_0:
		push temp					;   R16
    	in temp,SREG      			;
   		push temp         			;   SREG
		push temp1					;   
		push R0						;
		push R1						;
		push R6						;
			;   
		lds temp,T_clk				; 
		sts prv_T,temp				;   
		lds temp,T_clk+1			; 
		sts (prv_T+1),temp			;   
		lds temp,T_clk+2			; 
		sts (prv_T+2),temp			;    
			; 1 
		lds temp,T_clk				;    
		rcall BCD_HEX				;  BCD  HEX
		inc temp					;   1
		cpi temp,60					;  60 ., 
		brge inc_min				;   
		rcall HEX_BCD				;  HEX  BCD
		sts T_clk,temp				;   
		rjmp wyh_int				;   
inc_min:	; 1 
		clr temp					; 
		sts T_clk,temp				;    00 
		
		lds temp,T_clk+1			;    
		rcall BCD_HEX				;  BCD  HEX
		inc temp					;   1
		cpi temp,60					;  60 ., 
		brge inc_h					;   
		rcall HEX_BCD				;  HEX  BCD
		sts T_clk+1,temp			;   
		rjmp end_int				;   
inc_h:		; 1 
		clr temp
		sts T_clk+1,temp			;    00 
		
		lds temp,T_clk+2			;    
		rcall BCD_HEX				;  BCD  HEX
		inc temp					;   1
		cpi temp,24					;  24 , 
		brge clr_Tm					;    
		rcall HEX_BCD				;  HEX  BCD
		sts T_clk+2,temp			;   
		rjmp end_int				;
clr_Tm:		;    24:00
		clr temp					;
		sts T_clk,temp				;    00 
		sts T_clk+1,temp			;    00 
		sts T_clk+2,temp			;    00 
end_int:
		rcall Cur_T					;    
wyh_int:
		pop R6						;    
		pop R1						;
		pop R0						;
		pop temp1					;
		pop temp					;   SREG
    	out SREG,temp     			;
    	pop temp          			;   R16
		
		reti
;===========================================================================
mode_s:		;   /
		clr R10						;  .  
		tst R8						;   
		brne rev					;
		mov R8,R2					;   
		rjmp rev_end				;
rev:	clr R8						;    
		
rev_end:clr temp					; temp    
 		ret
;===========================================================================
freq_Up: 	;   "+"   
		cli
		inc freq					; 
		cpi freq,210				;    >210
		brlo PC+2					; 210+870=1080
		clr freq					;  freq =0
			;  ""
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				; .  LCD
		rcall Mono					; ""
			;     
		ldi temp,0b10010011			;(02H) ., DMUTE=0,,,
									; SEEKUP=1, SEEK=1 ( )
		mov r5,temp					; - 
r_con:	rcall Config_RDA5807		; 
		
nov_p:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_p					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rjmp r_con					;  
		
		rjmp st_tn					;  
		clr temp					; temp    
		sei
 		ret
;===========================================================================
freq_Down:		;   "-"   
		cli
		dec freq					; 
			;  ""
		POZ_LCD 0,5					;0- , 5- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				; .  LCD
		rcall Mono					; ""
			;     
		ldi temp,0b10010001			;(02H) ., DMUTE=0,,,
									; SEEKUP=0, SEEK=1 ( )
		mov r5,temp					; - 
rm_con:	rcall Config_RDA5807		; 
		
nov_m:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_m					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		tst freq					;    =0
		brne PC+2					; 210+870=1080
		ldi freq,210				;  freq =210
		rjmp rm_con					;  
		
		;     
st_tn:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									; SEEKUP=1, SEEK=0 ( )
		mov r5,temp					; - 
		rcall Config_RDA5807		; 
		
		sbrc r17,2					; , -
		rcall Ster					; ""
		rcall type_lev				;  
		rcall type_vol				;    LCD
		rcall rekog					; 
		rcall Prnt_F				;   
		
		clr temp					; temp    
		sei
 		ret
;===========================================================================
 St_Up:			;     FLASH
 		cli
 		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
		;  
		inc R9						;  
		mov temp,R9
 		cpi temp,Nst				;    > Nst
 		brlo st_u					;
 		clr R9						;     
 		rjmp st_set					;
 		
;---------------------------------------------------------------------------
St_Down:	;     FLASH
		cli
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
		;  
 		dec R9						;   ,
 		tst R9						;   > 0,  
 		brpl st_u					;   ,  -
 		ldi temp,(Nst-1)			;     
 		mov R9,temp					;
 		;     . 
 st_u:	breq st_set					;  =0,   
 		push R9						;
		adiw Z,16					;    . 
		dec R9						;
		brne PC-2					;
		pop R9						;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		rcall Print					;    
		rcall Prnt_F				;   
		;   
ch_st:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									 ;SEEKUP=1, SEEK=0 ( )
		mov r5,temp					;
		rcall Config_RDA5807		;  /
		
		rcall Mono					; ""
		DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		rcall Ster					; ""
		rcall type_lev				;  
		rcall type_vol				;    LCD
		
		clr temp					; temp    
		sei
		ret
		
;===========================================================================
;		/  
;---------------------------------------------------------------------------
rekog:
		cli							;
		clr R9						;  
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
rd_fr:	lpm temp,Z					;   FLASH
		cp temp,freq				;  ,   ,  -
		breq na_ind					;    
		inc R9						;  
		mov temp,R9					;  , 
		cpi temp,Nst				;    , -
		brsh fall					;  . ". "
		adiw Z,16					;   
		rjmp rd_fr					;  
		
fall:	LOAD_ADDR Z,Messg2*2		;  . ". "
		rjmp PC+2					;  
		
na_ind:	adiw Z,1					;    
			;    
Print:	POZ_LCD 0,5					;0- , 5- 
		rcall Str_LCD				;    
		sei
		ret
		
;===========================================================================
;			 /   RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:
		cli
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		rcall IIC_Recieve		;(0)   
		sts seek_fm,temp		;    . 
		
		rcall IIC_Recieve		;(0L)   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Recieve_lst	;(0B)   
		lsr temp				;   
		sts level,temp			;      
		
		rcall IIC_Stop			;  
		sei
		
		ret
		
;===========================================================================
;	 /    , ( YH:YL   )
;---------------------------------------------------------------------------
Rd_St:	
		cli
		ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		clr freq					;
Rd_EEF:	sbic EECR,EEWE				;   
		rjmp Rd_EEF					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in freq,EEDR				;   . 
		
		inc YL						;
Rd_EEV:	sbic EECR,EEWE				;   
		rjmp Rd_EEV					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in temp,EEDR				;   . 
		andi temp,0x0F				;  
		sts volume,temp				;    
		sei
		
		ret
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 
		cli
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		
		mov temp,r5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		ldi temp,0					;(04H)
		rcall IIC_Send				;
		ldi temp,0					;(04L)
		rcall IIC_Send				;
		
		ldi temp,0b10001000 		;(05H)- .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;  
		
		rcall iic_stop 				; 
		rcall Wr_EEF				;    
		rcall Wr_EEV				;   
		
		pop R16          		;   SREG
    	out SREG,R16     		;
    	pop R16          		;   R16
		sei
		ret
;===========================================================================
;		    ,  YH:YL   
;---------------------------------------------------------------------------
Wr_EEF:	cli
		ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,freq				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei
		ret
; ========================================================================
;		    ,  YH:YL   
;-------------------------------------------------------------------------
Wr_EEV:	cli
		ldi YL,LOW(Vol_EE)			;.  Y . ..
		clr YH						; .   
		lds temp,volume				;    
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,temp				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei
		ret
; ========================================================================
		; 
vol_up:
		lds temp,volume		;    
		cpi temp,15			;  
		breq vol_pl			; ,  
		inc temp			; 
		sts volume,temp		;  
vol_pl:	rcall wr_vol		;   RDA5807m
		DELAY 10			; 323
		clr temp			; temp    
		ret
;===========================================================================
		; 
vol_dw:
		lds temp,volume		;    
		cpi temp,0			;  
		breq vol_mi			; ,  
		dec temp			; 
		sts volume,temp		;  
vol_mi:	rcall wr_vol		;   RDA5807m
		DELAY 10			; 323 
		clr temp			; temp    
		ret
		
; ========================================================================
; /    RDA5807M     0x22
;-------------------------------------------------------------------------
wr_vol:	;     RDA5807
		cli
		rcall iic_start				;  ""
		ldi temp,0x22				;  
		rcall IIC_Send				;  
		
		ldi temp,0x05				;  (05H)  
		rcall IIC_Send				;
		
		ldi temp,0b10001000  		;(05H) - .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;   RDA5807m
		
		rcall iic_stop 				;  ""
		rcall type_vol				;   
		sei
		ret
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_vol:	;    LCD
		cli
		POZ_LCD 6,0					;6- , 0- 
			;   10- 
		clr R17						;
		lds temp,volume				;    
		andi temp,0x0F				;  
		rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum)			;.  X . .   
		clr YH						;
		inc YL						; .    
			;    LCD 
		ld temp,Y					; .  
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		ld temp,-Y					; .  
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			; .    LCD
		sei
		ret
		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_lev:
		cli
		;    LCD
		POZ_LCD 0,0					;0- , 0- 
		lds temp,level				;     
		
		cpi temp,51					; 4- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg10*2		;.  Z . . " 4"
		rjmp tp_lev					;    /
		
		cpi temp,38					; 3- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg9*2		;.  Z . . " 3"
		rjmp tp_lev					;    /
		
		cpi temp,25					; 2- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg8*2		;.  Z . . " 2"
		rjmp tp_lev					;    /
		
		cpi temp,12					; 1- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg7*2		;.  Z . . " 1"
		rjmp tp_lev					;    /
		
		LOAD_ADDR Z,Messg6*2		;.  Z . . " 0"
		
tp_lev:	rcall Str_LCD				;   
		sei
		ret

;===========================================================================
; /     0
;---------------------------------------------------------------------------
OVF_T0:	 cli
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;
		dec time			; 
		
t_1:	tst r1				;     
		breq vyh			;   /,  -
		mov r2,r1			;    
		
vyh:	pop R16          	;   SREG
    	out SREG,R16     	;
    	pop R16          	;   R16
		sei
		reti
		
;===========================================================================
; /     1
;---------------------------------------------------------------------------
OVF_T1:	
		rcall U_bat         ;   
		
		reti
		
;===========================================================================
; /     2
;---------------------------------------------------------------------------
OVF_T2:	
		push R19          	;   R19
    	in R19,SREG      	;
   		push R19         	;   SREG
		;
podsv:	dec R12				; 
		tst r12				;    , -
		brne wyh			;   /,  -
		sbi PORTD,6			;  
		cbi PORTD,7			;  
		ldi R19,0			;  2
		out TCCR2,R19		;
		
		sbrs R13,0			;    , 
   		rjmp wyh			;
   		rcall pwr_off		;    
		
		;
wyh:	pop R19          	;   SREG
    	out SREG,R19     	;
    	pop R19          	;   R19
		
		reti
		
;===========================================================================
;		    LCD 
;---------------------------------------------------------------------------
 Prnt_F:		;      
 		cli
		;    LCD
		ldi temp,1				;1- , 1- 
		mov R6,temp				;   
		rcall lcd_XClk			;    
		ldi R16,1				;
		rcall lcd_Y				;  1- 
		;    
		clr r18					;
		ldi r17,HIGH(870)		;  
		ldi temp,LOW(870)		; : 870  
		add temp,freq			;   
		adc r17,r18				;
		;   10- 
		rcall bin16_dec5		;  10- 
		LOAD_ADDR Y,decnum+3	;.  Y . .   
		;  
		ld temp,Y				; .  
		tst temp				;    0,  -
		brne PC+4				;    
		ldi temp,0x0A			;  
		rcall Dig_x2			;  LCD 
		rjmp PC+2				
		rcall Dig_x2			;  
		
		ld temp,-Y				; .  
		rcall Dig_x2			;  
		
		ld temp,-Y				; .  
		rcall Dig_x2			;  
		
		;  LCD 
		ldI temp,0x20			;   
		rcall lcd_put_char		;
		ldI temp,7				;
		rcall lcd_XClk			;    
		ldi temp,2				;
		rcall lcd_Y				;  2 
		ldI temp,127			; 
		rcall lcd_put_char		;  LCD 
		
		;  LCD   
		inc R6					;  
		ldI temp,8				;
		rcall lcd_XClk			;    
		ldi temp,1				;
		rcall lcd_Y				;  1 
		ld temp,-Y				; .  
		rcall Dig_x2			;   
		
		;    ""
		POZ_LCD 9,2				;9- , 2- 
		LOAD_ADDR Z,Messg4*2	;.  Z . . ""
		rcall Str_LCD			;   
		sei
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Mono:	;    LCD
		POZ_LCD 13,0				;13- , 0- 
		ldi temp,'M'				;
		rcall lcd_put_char			;  ""  LCD
		cbi PORTB,0					; 
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Ster:	;    LCD
		POZ_LCD 13,0				;13- , 0- 
		ldi temp,'S'				;
		rcall lcd_put_char			;  "S"  LCD
		sbi PORTB,0					; 
		ret
		
;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	cli
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:R16,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     sei
     ret

;===========================================================================
;		/       
;---------------------------------------------------------------------------
U_bat:	cli
		;  
		sbi ADCSR,ADSC			;  
cnv: 	sbis  ADCSR,ADIF		;   ,
     	rjmp  cnv				;   
     	sbi   ADCSR,ADIF		;   
     	in temp,ADCL			; .   
  		sts akkum,temp			;  
		in temp,ADCH			; .   
		sts akkum+1,temp		;  
		
		;    
		sbis PIND,5					;  , 
		rcall U_batt				;    
		
		;    LCD
		POZ_LCD 10,0				;0- ,10- 
		;
		lds temp1,akkum				;    
		lds temp2,akkum+1			;
		
		ldi temp,HIGH(Ubat_3)		; 3- 
		cpi temp1,LOW(Ubat_3)		;
		cpc temp2,temp				;
		brmi PC+4					;
		LOAD_ADDR Z,Messg16*2		;   . " 3"
		rjmp tp_bat					;    /
		
		ldi temp,HIGH(Ubat_2)		; 2- 
		cpi temp1,LOW(Ubat_2)		;
		cpc temp2,temp				;
		brmi PC+4					;
		LOAD_ADDR Z,Messg15*2		;   . " 2"
		rjmp tp_bat					;    /
		
		ldi temp,HIGH(Ubat_1)		; 1- 
		cpi temp1,LOW(Ubat_1)		;
		cpc temp2,temp				;
		brmi PC+4					;
		LOAD_ADDR Z,Messg14*2		;   . " 1"
		rjmp tp_bat					;    /
		
		ldi temp,HIGH(Ubat_0)		; 0- 
		cpi temp1,LOW(Ubat_0)		;
		cpc temp2,temp				;
		brmi avar					;
		LOAD_ADDR Z,Messg13*2		;   . " 0"
		rjmp tp_bat
		
		;  . 
avar:	cbi PORTB,0					; 
		rcall lcd_clr				; LCD
		POZ_LCD 0,1					;1- ,0- 
		LOAD_ADDR Z,Messg17*2		;  . " "
		rcall Str_LCD				; .  
		
		inc R13						;   
		ldi temp,80					;   
		mov R12,temp				; " "
		ldi temp,0b00000111			;  2   1/1024
		out TCCR2,temp				;
		
wt_av:	nop							;  
		rjmp wt_av					;
		
tp_bat:	rcall Str_LCD				;   
		sei
		ret
		
;=========================================================================
;		/   
;---------------------------------------------------------------------------
pwr_off:	
		;   RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		ldi temp,0b11010010			; - 
		rcall IIC_Send				;(02) = r5
		ldi temp,0					;Power Up =0
		rcall IIC_Send				;  RDA5807
		rcall iic_stop 				; 
		;  
		sbi PORTD,6						;  
		cbi PORTD,7						;  
		rcall lcd_clr					; LCD
		ldi temp1,1 					;-  = 1
		cbi LCD_SCE_port,LCD_SCE 		;  (SCE=0)
		cbi LCD_DC_port,LCD_DC 			; D/C =0   
		ldi temp,0x25					; . 
		mov R0,temp						;
		rcall lcd_send1					; 1   LCD
		sbi LCD_SCE_port,LCD_SCE		;.  LCD
		;    
		ldi temp1,0b10100000	 		;
		out MCUCR,temp					;  Power down
		sleep							;!
		
		ret
		
;===========================================================================
;		/      LCD  
;---------------------------------------------------------------------------
U_batt:	
		;    LCD
		cli
		POZ_LCD 0,4					;0- , 4- 
		;
		ldi temp,Typ_Bat			; . . ,
		tst temp					;  6...10 ,  -
		brne ur_b					;    2
		
		;      
		lds temp,akkum				;   
		lds R17,akkum+1				;  
		lsr R17						;   2
		ror temp					;
		rjmp tu_pr					;
		
ur_b:	lds temp,akkum				;   
		lds R17,akkum+1				;  
		
		;  10- 
tu_pr:	rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum+3)		;.  X . 
		clr YH						; .    
		;     LCD 
		ld temp,Y					;  
		tst temp					;   0, 
		breq bez0					;    
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			;    LCD
	
bez0:	ld temp,-Y					;  
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			;    LCD
		
		ldi temp,','				;  
		rcall lcd_put_char			;   LCD
		
		ld temp,-Y					;   
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			;     LCD
		ld temp,-Y					;   
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			;     LCD
		
		ldi temp,'V'				;  c "V"
		rcall lcd_put_char			; c "V"  LCD
		ldi temp,' '				;  
		rcall lcd_put_char			;   LCD
		sei
		ret
		
;******************************************************************************
	.include "I2C_hard_driver.asm"		;   I2C
 	.include "Driver_DS1307.asm"		;   
 	.include "Nokia5110_driver.asm"		; LCD Nokia5110
 	.include "User_set.asm"				; 
;******************************************************************************
;==============================================================================
		;     

  Messg1:  .DB  130,131,131,' ',' ',142,' ',' ',' ',' ',' ',' ',' ',' ', 0,0
  Messg2:  .DB  ' ','','','','','','.',' ','','','','','',' ', 0,0
  Messg3:  .DB  146,146,146,146,146,146,146,146,146,146,146,146,146,146, 0,0
  Messg4:  .DB  '','','',0
  Messg5:  .DB  ' ',' ','','','','','','','','','',' ',' ',' ', 0,0
  Messg6:  .DB  130,131,131, 0		; 0
  Messg7:  .DB  130,132,131, 0		; 1
  Messg8:  .DB  130,133,131, 0		; 2
  Messg9:  .DB  130,133,134, 0		; 3
  Messg10: .DB  130,133,135, 0		; 4
;  Messg11: .DB  ' ','','','','',' ', 0,0
;  Messg12: .DB  '','','','','','', 0,0
  Messg13: .DB  136,137,141, 0		; 0
  Messg14: .DB  136,138,141, 0		; 1
  Messg15: .DB  136,139,141, 0		; 2
  Messg16: .DB  140,139,141, 0		; 3
  Messg17: .DB  "            ", 0,0
  Messg18: .DB  " .  ",0,0
  Messg19: .DB  " .  ",0,0
  
;-------------------------------------------------------------------------------

		.EXIT
		
		